<template>
  <ob-form
    :form-data="formData"
    :user-access="userAccess"
    :is-active-element="formData.is_active"
    @submit="onSubmitHandler"
    @close="onClose"
    @change-active="onChangeActive"
    ref="form-location"
  >
    <ob-tabs v-model="selectedTab" :items="tabsItems">
      <ob-tabs-pane :title="dictionaryRu.modal.info" class="ob_location_modal">
        <div class="row">
          <div class="col-xs-4">
            <ob-selector
              :items="filteredLocationTypes"
              :disabled="!isNew"
              :label="dictionaryRu.modal.location_type"
              :placeholder="dictionaryRu.FORM_PLACEHOLDERS.select"
              v-model="formData.location_type_uuid"
              :required="true"
              display-exp="name"
            />
          </div>
          <div class="col-xs-4">
            <ObAddressInput
              v-if="isNew"
              v-model="location"
              display-exp="russian_address"
              :title="dictionaryRu.modal.center"
              :mapAddress="location"
              :placeholder="dictionaryRu.FORM_PLACEHOLDERS.selectOnMap"
              :disabled="!isNew"
              isAddressOnly
              required
              @input="setAddressFrom"
            />
            <ob-input
              v-else
              :value="coordinatesStr"
              disabled
              required
              :label="dictionaryRu.modal.center"
              :placeholder="dictionaryRu.FORM_PLACEHOLDERS.selectOnMap"
              icon="map"
            />
          </div>
          <div class="col-xs-4">
            <ob-input
              :label="dictionaryRu.modal.country"
              :disabled="true"
              :placeholder="dictionaryRu.modal.show_center"
              ref="country"
              v-model="formData.short_title"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <label>
              <svg
                class="flag"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 32 28"
              >
                <g filter="url(#filter0_d)">
                  <path fill="#0039A6" d="M6 11.5h20v5H6z" />
                  <path
                    d="M6 7.5a1 1 0 011-1h18a1 1 0 011 1v4H6v-4z"
                    fill="#fff"
                  />
                  <path
                    d="M6 16.5h20v4a1 1 0 01-1 1H7a1 1 0 01-1-1v-4z"
                    fill="#E62D3B"
                  />
                </g>
                <defs>
                  <filter
                    id="filter0_d"
                    x="0"
                    y=".5"
                    width="32"
                    height="29"
                    filterUnits="userSpaceOnUse"
                    color-interpolation-filters="sRGB"
                  >
                    <feFlood flood-opacity="0" result="BackgroundImageFix" />
                    <feColorMatrix
                      in="SourceAlpha"
                      values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0"
                    />
                    <feOffset />
                    <feGaussianBlur stdDeviation="3" />
                    <feColorMatrix
                      values="0 0 0 0 0 0 0 0 0 0.294118 0 0 0 0 0.784314 0 0 0 0.2 0"
                    />
                    <feBlend
                      in2="BackgroundImageFix"
                      result="effect1_dropShadow"
                    />
                    <feBlend
                      in="SourceGraphic"
                      in2="effect1_dropShadow"
                      result="shape"
                    />
                  </filter>
                </defs>
              </svg>
              {{ dictionaryRu.modal.ru_lang }}
            </label>
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.russian_address"
              :disabled="true"
              :placeholder="dictionaryRu.modal.russian_address_placeholder"
              ref="inputCoordinates"
              v-model="formData.russian_address"
            />
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.russian_name"
              placeholder="Введите название"
              ref="inputCoordinates"
              v-model="formData.russian_name"
              required
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <label>
              <svg
                class="flag"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
                xmlns:xlink="http://www.w3.org/1999/xlink"
                viewBox="0 0 32 28"
              >
                <g filter="url(#filter0_d)">
                  <path fill="url(#pattern0)" d="M6 6.5h20v15H6z" />
                </g>
                <defs>
                  <pattern
                    id="pattern0"
                    patternContentUnits="objectBoundingBox"
                    width="1"
                    height="1"
                  >
                    <use
                      xlink:href="#image0"
                      transform="matrix(.015 0 0 .02 -.25 0)"
                    />
                  </pattern>
                  <filter
                    id="filter0_d"
                    x="0"
                    y=".5"
                    width="32"
                    height="29"
                    filterUnits="userSpaceOnUse"
                    color-interpolation-filters="sRGB"
                  >
                    <feFlood flood-opacity="0" result="BackgroundImageFix" />
                    <feColorMatrix
                      in="SourceAlpha"
                      values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 127 0"
                    />
                    <feOffset />
                    <feGaussianBlur stdDeviation="3" />
                    <feColorMatrix
                      values="0 0 0 0 0 0 0 0 0 0.294118 0 0 0 0 0.784314 0 0 0 0.2 0"
                    />
                    <feBlend
                      in2="BackgroundImageFix"
                      result="effect1_dropShadow"
                    />
                    <feBlend
                      in="SourceGraphic"
                      in2="effect1_dropShadow"
                      result="shape"
                    />
                  </filter>
                  <image
                    id="image0"
                    width="100"
                    height="50"
                    xlink:href="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAGQAAAAyCAMAAACd646MAAAApVBMVEUAJH1Vbaj///9WbqnPFCvi5vDbTl/zxMoCJn5UbKjU2ulXb6nk6PHl6fLwtLsBJX7T2enbT2DTKD1ZcKpbcqvW3OrY3uuOnsWPn8bfYXHfYnLhbXzhbnzhb33ib32Qn8aRoMcDJ3/niJTniZTojpnoj5rpkZzpk57SJTrwtr3wt77TJjz319v32Nz88vP98/T99PX99fb+9/j++Pj++fr++vvTJzwm3ws1AAABN0lEQVR42u3Xt27FMAxGYYqW2+3pvffe8/6PlqvBGQQaJ1yCIPCZf+DbBEqqWrs21hrpL6hq/E5VW+nvZH1TH8+vY6qqJUZgAGFCdYkAAwgTS+QzAgMIEgl5vgQGECQSMlJgAGFCF9KMgQGEiTAXIYYRJgQYRphghhEmmAEECAdjI0y4GBNBws0YCBJ+psiRAgk/M8mR6c+JYFRsl/p2c7ibOnvQrgx5n+3ni3KrCEaimI14+kdI/IUGZEAG5I8gwwPpQ1qj4niqXfenO6mD248MyRd7s1edHIXWqOcy76qrmFq9etEyR8p8dXfxBL81IBahyJEwHgHjJebWSdQA4yXs4w4YL2EjwHgJGwHGQQDCDBOIMMMEI8wwwQgzRDDCjBDBCDNCBCPMCBGMMCNEMMKMAMEIMytfZZZd/8K7Cz4AAAAASUVORK5CYII="
                  />
                </defs>
              </svg>
              {{ dictionaryRu.modal.en_lang }}
            </label>
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.english_address"
              :disabled="true"
              :placeholder="dictionaryRu.modal.english_address_placeholder"
              ref="inputCoordinates"
              v-model="formData.english_address"
            />
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.english_name"
              placeholder="Введите название"
              ref="inputCoordinates"
              v-model="formData.english_name"
              required
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <label>
              {{ dictionaryRu.modal.local_lang }}
            </label>
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.local_address"
              :disabled="true"
              :placeholder="dictionaryRu.modal.local_address_placeholder"
              ref="inputCoordinates"
              v-model="formData.local_address"
            />
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.local_name"
              placeholder="Введите название"
              ref="inputCoordinates"
              v-model="formData.local_name"
              required
            />
          </div>
        </div>
      </ob-tabs-pane>
      <ob-tabs-pane
        :title="dictionaryRu.modal.radius"
        :is-hidden="!formData.location_radius"
      >
        <template v-if="formData.location_radius">
          <div class="row">
            <div class="col-xs-6">
              <ob-input
                v-model.number="
                  formData.location_radius.zero_interrogation_radius
                "
                :label="RADIUS_LABEL.zero_interrogation_radius"
                subTitle="км"
              />
            </div>
            <div class="col-xs-6">
              <ob-input
                v-if="activeLocationType !== 'RAILWAY_TERMINAL'"
                v-model.number="formData.location_radius.hard_binding_radius"
                :label="RADIUS_LABEL.hard_binding_radius"
                subTitle="км"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-6">
              <ob-input
                v-model.number="formData.location_radius.vehicle_arrival_radius"
                :label="RADIUS_LABEL.vehicle_arrival_radius"
                subTitle="км"
              />
            </div>
            <div class="col-xs-6">
              <ob-input
                v-model.number="
                  formData.location_radius.vehicle_departure_radius
                "
                :label="RADIUS_LABEL.vehicle_departure_radius"
                subTitle="км"
              />
            </div>
          </div>
        </template>
      </ob-tabs-pane>
      <template v-if="showStationsTab">
        <ob-tabs-pane :title="`${dictionaryRu.modal.stations} ${formData.rail_stations.length > 0 ? formData.rail_stations.length : ''}`">
          <div class="row">
            <div class="col">
              <ob-selector
                ref="stationsSelect"
                v-model="formData.rail_stations"
                :remote-opt="{
                  method: getRailStations,
                }"
                :initialValue="activeRailStations"
                label="Обслуживающие ЖД станции"
                placeholder="Выберите из списка"
                icon="plus"
                isDropdown
                isAutoComplete
                data-qa="stationsSelect"
              />
            </div>
          </div>
        </ob-tabs-pane>
      </template>
      <template v-if="showServingTerminalsTab">
        <ob-tabs-pane
            :title="dictionaryRu.modal.serving_terminals"
        >
          <div class="row">
            <div class="col-xs-6">
              <ob-selector
                  ref="railwayTerminalSelect"
                  v-model="formData.railway_terminal_uuid"
                  :remote-opt="{
                    method: getRailwayTerminals,
                  }"
                  label="Обслуживающий ЖД терминалы"
                  placeholder="Выберите из списка"
                  popperClass="location-terminal-select"
                  isAutoComplete
                  data-qa="railwayTerminalSelect"
              />
            </div>
            <div class="col-xs-6">
              <ob-selector
                  ref="railwayRerminalContainerSelect"
                  v-model="formData.container_terminal_uuid"
                  :remote-opt="{
                    method: getRailwayRerminalContainers,
                  }"
                  :details-remote="{
                    method: getSelectedRailwayRerminalContainers
                  }"
                  label="Обслуживающий контейнерные терминалы"
                  placeholder="Выберите из списка"
                  popperClass="location-terminal-select"
                  isAutoComplete
                  data-qa="railwayRerminalContainerSelect"
              />
            </div>
          </div>
        </ob-tabs-pane>
      </template>
    </ob-tabs>
  </ob-form>
</template>

<script>
import api from "@/api";
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObAddressInput from "../addressInput.vue";
import models from "@/models";
import cloneDeep from "clone-deep";
import { RADIUS_LABEL } from "@/resources/enum";
import ObInput from "common-components/src/obComponents/obInput";
import ObSelector from "common-components/src/obComponents/obSelect";
import ObForm from "common-components/src/obComponents/obForm";
import ObTabs from "common-components/src/obComponents/obTabs";
import ObTabsPane from "common-components/src/obComponents/obTabs/ObTabsPane";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { dictionary } from "@/translations/ru/dictionaries__locations__locations_list";
import { dictionaryDefault } from "@/translations/ru/default";
import { getIconByLocation } from "@/helpers";

export default {
  name: "Location",
  components: {
    ObForm,
    ObInput,
    ObSelector,
    ObTabs,
    ObTabsPane,
    ObAddressInput,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: {
    disabledForm: {
      type: Boolean,
      default: true,
    },
    dataSource: {
      type: Object,
      required: true,
      default: () => {},
    },
    locationTypes: {
      type: Array,
      default: () => [],
    },
    activeRailStations: {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      selectedTab: { title: dictionary.modal.info, uuid: 1 },
      addressLocal: {},
      activeRadius: {},
      radiusObject: {},
      arrayOption: [],
      location: {
        coordinates: {
          lat: "",
          lon: "",
        },
        countryCode: "",
        label: "",
        locationUuid: "",
      },
      formData: {
        location_type_uuid: "",
        russian_name: "",
        english_name: "",
        english_address: "",
        russian_address: "",
        local_address: "",
        local_name: "",
        short_title: "",
        railway_terminal_uuid: "",
        container_terminal_uuid: ""
      },
      searchResults: [],
      RADIUS_LABEL,
    };
  },
  mounted() {
    if (!this.formData.location_radius.zero_interrogation_radius) {
      this.formData.location_radius.zero_interrogation_radius = 0;
    }
    if (!this.formData.location_radius.vehicle_arrival_radius) {
      this.formData.location_radius.vehicle_arrival_radius = 0;
    }
    if (!this.formData.location_radius.vehicle_departure_radius) {
      this.formData.location_radius.vehicle_departure_radius = 0;
    }
    if (!this.formData.location_radius.hard_binding_radius) {
      this.formData.location_radius.hard_binding_radius = 0;
    }
    if (this.isNew) {
      this.setDefaultParams();
    }
  },
  computed: {
    tabsItems() {
      return this.dataSource ? [
        {
          title: this.dictionaryRu?.modal.info,
          uuid: 1
        },
        {
          title: this.dictionaryRu?.modal.radius,
          uuid: 2
        },
        ...(this.showStationsTab ? [{
          title: `${this.dictionaryRu?.modal.stations} ${this.formData.rail_stations.length > 0 ? this.formData.rail_stations.length : ''}`,
          uuid: 3
        }] : []),
        ...(this.showServingTerminalsTab ? [{title: this.dictionaryRu?.modal.serving_terminals, uuid: 4}] : [])
      ] : []
    },
    activeLocationType() {
      if (!this.formData.location_type_uuid) return;
      const _type = this.locationTypes.find(type => {
        return type.uuid === this.formData.location_type_uuid;
      });
      return _type.code
    },
    showStationsTab() {
      return this.isRefPosition(this.formData.location_type_uuid) || this.activeLocationType === 'REFERENCE_POSITION';
    },
    showServingTerminalsTab() {
      return this.activeLocationType === 'RAILWAY_STATION';
    },
    formModel() {
      return models.locations.main;
    },
    isNew() {
      return !this.formData.uuid;
    },
    filteredLocationTypes() {
      let locations = this.locationTypes;

      if (this.isNew) {
        locations = locations.filter((type) => {
          return type.data_completion === "Вручную";
        });
      }

      return locations;
    },
    coordinatesStr() {
      if (this.formData.coordinates) {
        let { lat, lon } = this.formData.coordinates;

        return lat && lon ? `${lat}, ${lon}` : "";
      } else {
        return null;
      }
    },
    currentAddress() {
      let {
        coordinates,
        english_name,
        russian_name,
        english_address,
        russian_address,
        local_address,
        local_name,
      } = this.dataSource;
      if (this.dataSource.coordinates) {
        return {
          russian_name: russian_name,
          english_name: english_name,
          english_address: english_address,
          russian_address: russian_address,
          local_address: local_address,
          local_name: local_name,
          coordinates: coordinates,
        };
      } else {
        return null;
      }
    },
  },
  methods: {
    onChangeActive() {
      this.formData.is_active = !this.formData.is_active;
    },
    async getRailStations({ page, size, query }) {
      try {
        const res = await api.locations.getRailStations({ page, size, query });
        return res;
      } catch (err) {
        console.error(err);
      }
    },
    async getRailwayTerminals({ page, size, query }) {
      try {
        const res = await api.locations.getLocations( page, size, query, null, {
          location_type_code: "RAILWAY_TERMINAL"
        });
        res.data.content.unshift({uuid: null, title: 'Нет обслуживающего терминала'});
        return this.addIcons(res);
      } catch (err) {
        console.error(err);
      }
    },
    async getRailwayRerminalContainers({ page, size, query }) {
      try {
        const res = await api.locations.getLocations( page, size, query, null, {
          location_type_code: "CONTAINER_PORT"
        });
        res.data.content.unshift({uuid: null, title: 'Нет обслуживающего терминала'});
        return this.addIcons(res);
      } catch (err) {
        console.error(err);
      }
    },
    async getSelectedRailwayRerminalContainers() {
      if (!this.formData.container_terminal_uuid) return [];
      try {
        const { data } = await api.locations.getLocation(this.formData.container_terminal_uuid);
        return [{ ...data, icon: this.getIconByLocation(data.location_type_uuid)}];
      } catch (err) {
        console.error(err);
      }
    },
    addIcons(res) {
      if (res?.data?.content) {
        res.data.content.forEach(item => item.icon = this.getIconByLocation(item.location_type_uuid));
      }
      return res;
    },
    isRefPosition(locationTypeUuid) {
      if (!locationTypeUuid) return
      const _type = this.locationTypes.find(type => {
        return type.uuid === locationTypeUuid;
      });
      return _type.code && _type.code === 'REFERENCE_POSITION'
    },
    onClose() {
      this.selectedTab = { title: this.dictionaryRu.modal.info };
      this.location = {
        coordinates: {
          lat: "",
          lon: "",
        },
        countryCode: "",
        label: "",
        locationUuid: "",
      };
    },
    async setAddressFrom() {
      this.formData.coordinates = this.location.coordinates.lat && this.location.coordinates.lon ? this.location.coordinates : {lat: this.location.coordinates[0], lon: this.location.coordinates[1]};
      if (this.location.countryCode) {
        const country = await api.dictionaries.countries.getCountryByCode(
          this.location.countryCode
        );
        this.formData.country_symbol_code = country.symbol_code;
        this.formData.short_title = country.short_title;
      } else {
        const res = await api.geocoder.getLocationAddressByCoordinates({coordinates: `${this.location.coordinates[0]}, ${this.location.coordinates[1]}` })
        if (res.country_code) {
          const country = await api.dictionaries.countries.getCountryByCode(
          res.country_code);
          this.formData.country_symbol_code = country.symbol_code;
          this.formData.short_title = country.short_title;
        }
      }
    },
    activeDeleteStatus() {
      if (
        !this.isNew &&
        (!this.userAccess || (this.userAccess && this.userAccess.DELETE))
      ) {
        let _type = this.filteredLocationTypes.find((type) => {
          return type.uuid === this.formData.location_type_uuid;
        });
        return _type && _type.data_completion === "Вручную";
      }
      return false;
    },
    changeRadius(key) {
      this.radiusObject = cloneDeep({
        zero_interrogation_radius:
          Number(
            this.formData.location_radius.zero_interrogation_radius.value
          ) || this.formData.location_radius.zero_interrogation_radius,
        vehicle_arrival_radius:
          Number(this.formData.location_radius.vehicle_arrival_radius.value) ||
          this.formData.location_radius.vehicle_arrival_radius,
        vehicle_departure_radius:
          Number(
            this.formData.location_radius.vehicle_departure_radius.value
          ) || this.formData.location_radius.vehicle_departure_radius,
        hard_binding_radius: this.formData.location_radius.hard_binding_radius,
      });
      this.activeRadius = key;
      // todo в дальнейшем переделать метод передачи данных в модалку в целях избежания расхождения данных
      // this.$refs.radius.open()
    },
    setNextRadius(delta) {
      let _length = Object.keys(this.radiusObject).length;
      let _index;
      Object.keys(this.radiusObject).forEach((objectKey, index) => {
        if (objectKey === this.activeRadius) {
          if (delta === 1) {
            _index = index < _length - 1 ? index + 1 : 0;
          } else {
            _index = index === 0 ? _length - 1 : index - 1;
          }
        }
      });
      this.activeRadius = Object.keys(this.radiusObject)[_index];
    },
    viewCenterMap() {
      this.$refs.map.open();
    },
    onSubmitHandler() {
      if (
        !this.formData.location_radius.hasOwnProperty("hard_binding_radius")
      ) {
        this.formData.location_radius.hard_binding_radius = 0;
      }
      let data = cloneDeep(this.formData);
      data.members = data.members_uuid;
      data.rail_stations = data.rail_stations.map(item => {
        return {uuid: item};
      })
      this.$emit("submit", { formData: data, model: this.formModel });
    },
    setDefaultParams() {
      if (this.isNew) {
        this.formData.location_type_uuid = this.filteredLocationTypes[0].uuid;
      }
    },
    openMap(e) {
      if (this.$refs.mapSelector.isOpen) {
        this.$refs.mapSelector.close(e);
      }
      this.$refs.modalMap.open();
    },
    getIconByLocation
  },
  watch: {
    dataSource() {
      this.setDefaultParams();
    },
    "dataSource.location_radius.hard_binding_radius"() {
      this.$refs["form-location"].isSubmitDisabled = false;
      this.formData.location_radius.hard_binding_radius = this.dataSource.location_radius.hard_binding_radius;
    },
  },
};
</script>

<style scoped lang="scss">
.ob-selector.form-item-container {
  margin-top: 0 !important;
}
.ob_location_modal {
  .col-xs-12 {
    label {
      display: flex;
      align-items: center;
      margin-bottom: 5px;
    }
  }
}
.flag {
  width: 20px;
  margin-right: 5px;
}

.col {
  padding: 0 1rem;
  width: 100%;
}

.ob-selector {
  width: 100%;
}
</style>

<style>
.location-terminal-select .ob-selector__list-item-text:only-child {
  padding-left: 28px;
} 
</style>